]> git.proxmox.com Git - mirror_qemu.git/blob - scripts/qemu-binfmt-conf.sh
Merge remote-tracking branch 'remotes/kraxel/tags/ui-20180614-pull-request' into...
[mirror_qemu.git] / scripts / qemu-binfmt-conf.sh
1 #!/bin/sh
2 # enable automatic i386/ARM/M68K/MIPS/SPARC/PPC/s390/HPPA/Xtensa/microblaze
3 # program execution by the kernel
4
5 qemu_target_list="i386 i486 alpha arm armeb sparc32plus ppc ppc64 ppc64le m68k \
6 mips mipsel mipsn32 mipsn32el mips64 mips64el \
7 sh4 sh4eb s390x aarch64 aarch64_be hppa riscv32 riscv64 xtensa xtensaeb microblaze microblazeel"
8
9 i386_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x03\x00'
10 i386_mask='\xff\xff\xff\xff\xff\xfe\xfe\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
11 i386_family=i386
12
13 i486_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x06\x00'
14 i486_mask='\xff\xff\xff\xff\xff\xfe\xfe\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
15 i486_family=i386
16
17 alpha_magic='\x7fELF\x02\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x26\x90'
18 alpha_mask='\xff\xff\xff\xff\xff\xfe\xfe\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
19 alpha_family=alpha
20
21 arm_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x28\x00'
22 arm_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
23 arm_family=arm
24
25 armeb_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x28'
26 armeb_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
27 armeb_family=armeb
28
29 sparc_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x02'
30 sparc_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
31 sparc_family=sparc
32
33 sparc32plus_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x12'
34 sparc32plus_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
35 sparc32plus_family=sparc
36
37 ppc_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x14'
38 ppc_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
39 ppc_family=ppc
40
41 ppc64_magic='\x7fELF\x02\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x15'
42 ppc64_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
43 ppc64_family=ppc
44
45 ppc64le_magic='\x7fELF\x02\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x15\x00'
46 ppc64le_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\x00'
47 ppc64le_family=ppcle
48
49 m68k_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x04'
50 m68k_mask='\xff\xff\xff\xff\xff\xff\xfe\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
51 m68k_family=m68k
52
53 # FIXME: We could use the other endianness on a MIPS host.
54
55 mips_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08'
56 mips_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
57 mips_family=mips
58
59 mipsel_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08\x00'
60 mipsel_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
61 mipsel_family=mips
62
63 mipsn32_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08'
64 mipsn32_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
65 mipsn32_family=mips
66
67 mipsn32el_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08\x00'
68 mipsn32el_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
69 mipsn32el_family=mips
70
71 mips64_magic='\x7fELF\x02\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08'
72 mips64_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
73 mips64_family=mips
74
75 mips64el_magic='\x7fELF\x02\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08\x00'
76 mips64el_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
77 mips64el_family=mips
78
79 sh4_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x2a\x00'
80 sh4_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
81 sh4_family=sh4
82
83 sh4eb_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x2a'
84 sh4eb_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
85 sh4eb_family=sh4
86
87 s390x_magic='\x7fELF\x02\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x16'
88 s390x_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
89 s390x_family=s390x
90
91 aarch64_magic='\x7fELF\x02\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xb7\x00'
92 aarch64_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
93 aarch64_family=arm
94
95 aarch64_be_magic='\x7fELF\x02\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xb7'
96 aarch64_be_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
97 aarch64_be_family=armeb
98
99 hppa_magic='\x7f\x45\x4c\x46\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x0f'
100 hppa_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
101 hppa_family=hppa
102
103 riscv32_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xf3\x00'
104 riscv32_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
105 riscv32_family=riscv
106
107 riscv64_magic='\x7fELF\x02\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xf3\x00'
108 riscv64_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
109 riscv64_family=riscv
110
111 xtensa_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x5e\x00'
112 xtensa_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
113 xtensa_family=xtensa
114
115 xtensaeb_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x5e'
116 xtensaeb_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff'
117 xtensaeb_family=xtensaeb
118
119 microblaze_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xba\xab'
120 microblaze_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
121 microblaze_family=microblaze
122
123 microblazeel_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xab\xba'
124 microblazeel_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff'
125 microblazeel_family=microblazeel
126
127 qemu_get_family() {
128 cpu=${HOST_ARCH:-$(uname -m)}
129 case "$cpu" in
130 amd64|i386|i486|i586|i686|i86pc|BePC|x86_64)
131 echo "i386"
132 ;;
133 mips*)
134 echo "mips"
135 ;;
136 "Power Macintosh"|ppc64|powerpc|ppc)
137 echo "ppc"
138 ;;
139 ppc64el|ppc64le)
140 echo "ppcle"
141 ;;
142 arm|armel|armhf|arm64|armv[4-9]*l|aarch64)
143 echo "arm"
144 ;;
145 armeb|armv[4-9]*b|aarch64_be)
146 echo "armeb"
147 ;;
148 sparc*)
149 echo "sparc"
150 ;;
151 riscv*)
152 echo "riscv"
153 ;;
154 *)
155 echo "$cpu"
156 ;;
157 esac
158 }
159
160 usage() {
161 cat <<EOF
162 Usage: qemu-binfmt-conf.sh [--qemu-path PATH][--debian][--systemd CPU]
163 [--help][--credential yes|no][--exportdir PATH]
164
165 Configure binfmt_misc to use qemu interpreter
166
167 --help: display this usage
168 --qemu-path: set path to qemu interpreter ($QEMU_PATH)
169 --debian: don't write into /proc,
170 instead generate update-binfmts templates
171 --systemd: don't write into /proc,
172 instead generate file for systemd-binfmt.service
173 for the given CPU. If CPU is "ALL", generate a
174 file for all known cpus
175 --exportdir: define where to write configuration files
176 (default: $SYSTEMDDIR or $DEBIANDIR)
177 --credential: if yes, credential and security tokens are
178 calculated according to the binary to interpret
179
180 To import templates with update-binfmts, use :
181
182 sudo update-binfmts --importdir ${EXPORTDIR:-$DEBIANDIR} --import qemu-CPU
183
184 To remove interpreter, use :
185
186 sudo update-binfmts --package qemu-CPU --remove qemu-CPU $QEMU_PATH
187
188 With systemd, binfmt files are loaded by systemd-binfmt.service
189
190 The environment variable HOST_ARCH allows to override 'uname' to generate
191 configuration files for a different architecture than the current one.
192
193 where CPU is one of:
194
195 $qemu_target_list
196
197 EOF
198 }
199
200 qemu_check_access() {
201 if [ ! -w "$1" ] ; then
202 echo "ERROR: cannot write to $1" 1>&2
203 exit 1
204 fi
205 }
206
207 qemu_check_bintfmt_misc() {
208 # load the binfmt_misc module
209 if [ ! -d /proc/sys/fs/binfmt_misc ]; then
210 if ! /sbin/modprobe binfmt_misc ; then
211 exit 1
212 fi
213 fi
214 if [ ! -f /proc/sys/fs/binfmt_misc/register ]; then
215 if ! mount binfmt_misc -t binfmt_misc /proc/sys/fs/binfmt_misc ; then
216 exit 1
217 fi
218 fi
219
220 qemu_check_access /proc/sys/fs/binfmt_misc/register
221 }
222
223 installed_dpkg() {
224 dpkg --status "$1" > /dev/null 2>&1
225 }
226
227 qemu_check_debian() {
228 if [ ! -e /etc/debian_version ] ; then
229 echo "WARNING: your system is not a Debian based distro" 1>&2
230 elif ! installed_dpkg binfmt-support ; then
231 echo "WARNING: package binfmt-support is needed" 1>&2
232 fi
233 qemu_check_access "$EXPORTDIR"
234 }
235
236 qemu_check_systemd() {
237 if ! systemctl -q is-enabled systemd-binfmt.service ; then
238 echo "WARNING: systemd-binfmt.service is missing or disabled" 1>&2
239 fi
240 qemu_check_access "$EXPORTDIR"
241 }
242
243 qemu_generate_register() {
244 echo ":qemu-$cpu:M::$magic:$mask:$qemu:$FLAGS"
245 }
246
247 qemu_register_interpreter() {
248 echo "Setting $qemu as binfmt interpreter for $cpu"
249 qemu_generate_register > /proc/sys/fs/binfmt_misc/register
250 }
251
252 qemu_generate_systemd() {
253 echo "Setting $qemu as binfmt interpreter for $cpu for systemd-binfmt.service"
254 qemu_generate_register > "$EXPORTDIR/qemu-$cpu.conf"
255 }
256
257 qemu_generate_debian() {
258 cat > "$EXPORTDIR/qemu-$cpu" <<EOF
259 package qemu-$cpu
260 interpreter $qemu
261 magic $magic
262 mask $mask
263 EOF
264 if [ "$FLAGS" = "OC" ] ; then
265 echo "credentials yes" >> "$EXPORTDIR/qemu-$cpu"
266 fi
267 }
268
269 qemu_set_binfmts() {
270 # probe cpu type
271 host_family=$(qemu_get_family)
272
273 # register the interpreter for each cpu except for the native one
274
275 for cpu in ${qemu_target_list} ; do
276 magic=$(eval echo \$${cpu}_magic)
277 mask=$(eval echo \$${cpu}_mask)
278 family=$(eval echo \$${cpu}_family)
279
280 if [ "$magic" = "" ] || [ "$mask" = "" ] || [ "$family" = "" ] ; then
281 echo "INTERNAL ERROR: unknown cpu $cpu" 1>&2
282 continue
283 fi
284
285 qemu="$QEMU_PATH/qemu-$cpu"
286 if [ "$cpu" = "i486" ] ; then
287 qemu="$QEMU_PATH/qemu-i386"
288 fi
289
290 if [ "$host_family" != "$family" ] ; then
291 $BINFMT_SET
292 fi
293 done
294 }
295
296 CHECK=qemu_check_bintfmt_misc
297 BINFMT_SET=qemu_register_interpreter
298
299 SYSTEMDDIR="/etc/binfmt.d"
300 DEBIANDIR="/usr/share/binfmts"
301
302 QEMU_PATH=/usr/local/bin
303 FLAGS=""
304
305 options=$(getopt -o ds:Q:e:hc: -l debian,systemd:,qemu-path:,exportdir:,help,credential: -- "$@")
306 eval set -- "$options"
307
308 while true ; do
309 case "$1" in
310 -d|--debian)
311 CHECK=qemu_check_debian
312 BINFMT_SET=qemu_generate_debian
313 EXPORTDIR=${EXPORTDIR:-$DEBIANDIR}
314 ;;
315 -s|--systemd)
316 CHECK=qemu_check_systemd
317 BINFMT_SET=qemu_generate_systemd
318 EXPORTDIR=${EXPORTDIR:-$SYSTEMDDIR}
319 shift
320 # check given cpu is in the supported CPU list
321 if [ "$1" != "ALL" ] ; then
322 for cpu in ${qemu_target_list} ; do
323 if [ "$cpu" = "$1" ] ; then
324 break
325 fi
326 done
327
328 if [ "$cpu" = "$1" ] ; then
329 qemu_target_list="$1"
330 else
331 echo "ERROR: unknown CPU \"$1\"" 1>&2
332 usage
333 exit 1
334 fi
335 fi
336 ;;
337 -Q|--qemu-path)
338 shift
339 QEMU_PATH="$1"
340 ;;
341 -e|--exportdir)
342 shift
343 EXPORTDIR="$1"
344 ;;
345 -h|--help)
346 usage
347 exit 1
348 ;;
349 -c|--credential)
350 shift
351 if [ "$1" = "yes" ] ; then
352 FLAGS="OC"
353 else
354 FLAGS=""
355 fi
356 ;;
357 *)
358 break
359 ;;
360 esac
361 shift
362 done
363
364 $CHECK
365 qemu_set_binfmts